<?php
declare(strict_types=1);

namespace Inti\Container\Exception;

use Laminas\ServiceManager\PluginManagerInterface;
use Psr\Container\ContainerExceptionInterface;
use function sprintf;

/**
 * Class InvalidPluginManagerException
 *
 * @package Inti\Container\Exception
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-container
 */
class InvalidPluginManagerException extends RuntimeException implements ContainerExceptionInterface
{
    public static function classNotFound(string $className): self
    {
        return new self(sprintf(
            "Plugin manager '%s' could not be loaded.", $className
        ));
    }

    public static function isNotAPluginManager(string $className): self
    {
        return new self(sprintf(
            "%s is not a plugin manager; must implement '%s'.",
            $className, PluginManagerInterface::class
        ));
    }
}
